<?php
class ControllerModuleManufacturers extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('module/manufacturers');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('manufacturers', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');

		$data['entry_speed'] = $this->language->get('entry_speed');
		$data['entry_speedex'] = $this->language->get('entry_speedex');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_widthex'] = $this->language->get('entry_widthex');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_heightex'] = $this->language->get('entry_heightex');
		$data['entry_slider'] = $this->language->get('entry_slider');
		$data['entry_random'] = $this->language->get('entry_random');
		$data['entry_select'] = $this->language->get('entry_select');
		$data['entry_status'] = $this->language->get('entry_status');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['code'])) {
			$data['error_code'] = $this->error['code'];
		} else {
			$data['error_code'] = '';
		}

		if (isset($this->error['code1'])) {
			$data['error_code1'] = $this->error['code1'];
		} else {
			$data['error_code1'] = '';
		}

		if (isset($this->error['code2'])) {
			$data['error_code2'] = $this->error['code2'];
		} else {
			$data['error_code2'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('module/manufacturers', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['action'] = $this->url->link('module/manufacturers', 'token=' . $this->session->data['token'], 'SSL');

		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

		if (isset($this->request->post['manufacturers_speed'])) {
			$data['manufacturers_speed'] = $this->request->post['manufacturers_speed'];
		} else {
			$data['manufacturers_speed'] = $this->config->get('manufacturers_speed');
		}

		if (isset($this->request->post['manufacturers_width'])) {
			$data['manufacturers_width'] = $this->request->post['manufacturers_width'];
		} else {
			$data['manufacturers_width'] = $this->config->get('manufacturers_width');
		}

		if (isset($this->request->post['manufacturers_height'])) {
			$data['manufacturers_height'] = $this->request->post['manufacturers_height'];
		} else {
			$data['manufacturers_height'] = $this->config->get('manufacturers_height');
		}
		
		if (isset($this->request->post['manufacturers_slider'])) {
			$data['manufacturers_slider'] = $this->request->post['manufacturers_slider'];
		} else {
			$data['manufacturers_slider'] = $this->config->get('manufacturers_slider');
		}
		
		if (isset($this->request->post['manufacturers_random'])) {
			$data['manufacturers_random'] = $this->request->post['manufacturers_random'];
		} else {
			$data['manufacturers_random'] = $this->config->get('manufacturers_random');
		}

		if (isset($this->request->post['manufacturers_select'])) {
			$data['manufacturers_select'] = $this->request->post['manufacturers_select'];
		} else {
			$data['manufacturers_select'] = $this->config->get('manufacturers_select');
		}
		
		if (isset($this->request->post['manufacturers_status'])) {
			$data['manufacturers_status'] = $this->request->post['manufacturers_status'];
		} else {
			$data['manufacturers_status'] = $this->config->get('manufacturers_status');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/manufacturers.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/manufacturers')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['manufacturers_speed']) {
			$this->error['code'] = $this->language->get('error_code');
		}

		if (!$this->request->post['manufacturers_width']) {
			$this->error['code1'] = $this->language->get('error_code1');
		}
		
				if (!$this->request->post['manufacturers_height']) {
			$this->error['code2'] = $this->language->get('error_code2');
		}
		
		return !$this->error;
	}
}